program testastar;

{$mode objfpc}{$H+}

uses
  Classes, SysUtils, ConioEngine, Math, {uAStar, }crt
;

{.$R *.res}

const
  MAXX=100;
  MAXY=100;

  NMOBS = 100;

  NAMES='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';


type

  { TMob }

  TMob = class
    X, Y: Integer;
    Letter: Char;
    Color: Byte;
    procedure Process;
    constructor Create;
  end;

  TGetXYVal = function(X, Y: integer): boolean;stdcall;


  function DoAStar(MapX, MapY, FromX, FromY, ToX, ToY: integer; Callback: TGetXYVal; var TargetX, TargetY: integer): boolean;external 'BeaRLibPF.dll';


var
  I,J: Integer;
  c: char;

  PlayerX, PlayerY: Integer;
  PosX, PosY: Integer;
  Map: array[0..MAXX-1, 0..MAXY-1] of char;

  Mobs: array[1..NMOBS] of TMob;

function MyCallback(X, Y: Integer): Boolean;stdcall;
begin
  Result := Map[X, Y] = '.'
end;


{ TMob }

procedure TMob.Process;
var
  NewX, NewY: Integer;
begin
  Map[X, Y] := '.';
  if not DoAStar(MAXX, MAXY, X, Y, PlayerX, PlayerY, @MyCallback, NewX, NewY)then exit;
    //X := X+sign(PlayerX-X);
    //Y := Y+sign(PlayerY-Y);
  if (NewX = PlayerX) and (NewY = PlayerY) then
  begin
    X := random(MAXX);
    Y := random(MAXY);
    Map[X, Y] := '.';
  end
  else
  begin
    X := NewX;
    Y := NewY;
  end;
end;

constructor TMob.Create;
begin
  inherited;
  X := random(MAXX);
  Y := random(MAXY);
  Map[X, Y] := '.';
  Letter := NAMES[random(Length(NAMES))+1];
  if random<0.5 then
    Color := 2+7
  else
    Color := 5+7;
end;

begin
  UConioEngineInit;
  for I := 0 to MAXX-1 do
    for J := 0 to MAXY-1 do
      if random < 0.5 then
        Map[I, J]:='#'
      else
        Map[I, J]:='.';
  PlayerX := MAXX div 2;
  PlayerY := MAXY div 2;
  PosX := GetScreenWidth div 2;
  PosY := GetScreenHeight div 2;

  Map[PlayerX, PlayerY] := '.';
  for I := 1 to NMOBS do
    Mobs[I] := TMob.Create;
  repeat
    ConioEngineClear;
    //Map[random(MAXX), random(MAXY)] := '#';
    //Map[random(MAXX), random(MAXY)] := '.';

    for I := 0 to MAXX-1 do
      for J := 0 to MAXY-1 do
        ConioEngineWriteChar(I-PlayerX+PosX+1, J-PlayerY+PosY+1, Map[I, J], 7);

    for I := 1 to NMOBS do
    begin
      Mobs[I].Process;
      ConioEngineWriteChar(Mobs[I].X-PlayerX+PosX+1, Mobs[I].Y-PlayerY+PosY+1, Mobs[I].Letter, Mobs[I].Color);
    end;
    ConioEngineWriteChar(PosX+1, PosY+1, '@', 15);
    ConioEngineWriteString(1, 1, IntToStr(PlayerX)+', '+IntToStr(PlayerY), 15);

    UConioEngineRefresh;

    if KeyPressed then
    case ReadKey of
      '2': Inc(PlayerY);
      '4': Dec(PlayerX);
      '6': Inc(PlayerX);
      '8': Dec(PlayerY);
      Chr(27): break;
    end;
  until false;
end.

